
import org.isam.exehda.Exehda;
import org.isam.exehda.HostId;
import org.isam.exehda.ResourceName;
import org.isam.exehda.ResourceName.NameSpace;
import org.isam.exehda.services.CellInformationBase;


public class CibDemo
{
        //////////////////////////////////////////////////////////
        // MAIN
        //////////////////////////////////////////////////////////
    
        /**
         * List resources whose types have been provided as command-line arguments
         *
         * @param args a <code>String[]</code> value
         */
    public static void
    main( String[] args )
        {
            if ( args.length < 1 ) {
                System.out.println("Missing arguments");
                System.out.println("Usage: java CibDemo <resource type>...");
                System.exit(-1);
            }

            CellInformationBase cib = (CellInformationBase)
                Exehda.getService(CellInformationBase.SERVICE_NAME);

            NameSpace NS_THIS_CELL = HostId.getLocalHost().getCell().toNameSpace();

            for ( int i=0; i<args.length; i++ ) {
                System.out.println();
                System.out.println("Searching for resources of type '"+args[i]+"' in the local cell...");
                ResourceName[] result = cib.selectByType(args[i], NS_THIS_CELL, -1);

                System.out.println("Found #"+result.length+" resources matching type '"+args[i]+"'");
                for (int j=0; j<result.length; j++) System.out.println("\t"+result[j]);
            }
        }
}

