
import org.isam.exehda.Exehda;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed;
import org.isam.exehda.services.ObjectSeed.Activator;
import org.isam.exehda.services.ObjectSeed.MarshaledOX;


public class ObjSeedDemo
{
    public static class AnOX
        implements Runnable, java.io.Serializable
    {
        public AnOX( String name )
            {
                this.name = name;
                this.count = 0;
            }

        public void run()
            {
                System.out.println(name+" running!");
                while ( ! Thread.interrupted() ) {
                    System.out.println(name+" is working... step #"+(++count));
                    sleep(100);
                }

                System.out.println(name+" interrupted!");
            }

        private String name;
        private int count;
    }

    public static class AnActivator
        implements Activator
    {
        public void activate( ObjectId oxID, Object obj, MarshaledOX extState )
            {
                System.out.println("Activating "+obj);
                thr = new Thread( (AnOX) obj );
                thr.start();
            }

        public void deactivate( ObjectId oxID, Object obj, MarshaledOX oxState ) throws InterruptedException
            {
                System.out.println("\n\n\n\n\nDeactivating "+obj+"\n\n\n\n\n\n\n");
                thr.interrupt();
                thr.join();
                thr = null;
            }

        private transient Thread thr;
    }

    public static void
    sleep(long millis)
        {
            try {
                Thread.sleep(millis);
            }
            catch (InterruptedException ie)
            {
                Thread.currentThread().interrupt();
            }
        }
    
    public static void
    main( String[] args )
        {            
            ObjectSeed objectSeed = (ObjectSeed)
                Exehda.getService(ObjectSeed.SERVICE_NAME);

            ObjectId oxID = objectSeed.newInstance(AnOX.class, 
                                                   new Object[] { "OX1" }, 
                                                   new AnActivator()); 

            
            MarshaledOX oxState = new MarshaledOX();

            sleep(1000);
            
            objectSeed.deactivateObject(oxID, oxState);
            sleep(3000);

            objectSeed.activateObject(oxState);
            sleep(1000);

            objectSeed.deactivateObject(oxID, oxState);
            sleep(3000);

            objectSeed.activateObject(oxState);
            sleep(1000);

            objectSeed.deactivateObject(oxID, oxState);
        }
}
