
import org.isam.exehda.Exehda;
import org.isam.exehda.ObjectId;
import org.isam.exehda.services.ObjectSeed;
import org.isam.exehda.services.OXManager;
import org.isam.exehda.services.OXManager.OXHandle;


public class OXManagerDemo
{
    public OXManagerDemo()
        {
            System.out.println("<init>()");
        }

    public OXManagerDemo( String msg )
        {
            System.out.println("<init>(msg=\""+msg+"\")");            
        }
    
    
    public static void
    main( String[] args )
        {
                //
                // create an OX
                //
            ObjectSeed objectSeed = (ObjectSeed)
                Exehda.getService(ObjectSeed.SERVICE_NAME);

            ObjectId oxID = objectSeed.newInstance(OXManagerDemo.class, null, null);

                //
                // Interact with the OXManager
                //
            OXManager oxman = (OXManager)
                Exehda.getService(OXManager.SERVICE_NAME);

            OXHandle oxh = oxman.createHandle(oxID);
            System.out.println("     key="+oxh.getKey());
            
            System.out.println("After createHandle()");
            System.out.println(oxh);
            System.out.println("      id="+oxh.getId());
            System.out.println("     key="+oxh.getKey());
            System.out.println("   owner="+oxh.getOwner());
            System.out.println("     key="+oxh.getKey());
            System.out.println("location="+oxh.getLocation());
            System.out.println("     key="+oxh.getKey());

            oxman.grantOwnership(oxh);
            
            System.out.println("After grantOwnership()");
            System.out.println(oxh);
            System.out.println("      id="+oxh.getId());
            System.out.println("   owner="+oxh.getOwner());
            System.out.println("location="+oxh.getLocation());


            System.out.println("After requestOwnership()");
            System.out.println(oxh);
            System.out.println("      id="+oxh.getId());
            System.out.println("   owner="+oxh.getOwner());
            System.out.println("location="+oxh.getLocation());
        }
}
